unit ldn004u1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, StdCtrls;

const ver='2 Aug 2011';

type

  { TLDN004f1 }

  TLDN004f1 = class(TForm)
    buQuit: TButton;
    eCels: TEdit;
    eFahr: TEdit;
    laCels: TLabel;
    laFahr: TLabel;
    procedure buQuitClick(Sender: TObject);
    procedure eCelsKeyPress(Sender: TObject; var Key: char);
    procedure eFahrChange(Sender: TObject);
    procedure eCelsChange(Sender: TObject);
    procedure eFahrKeyPress(Sender: TObject; var Key: char);
    procedure FormCreate(Sender: TObject);
  private
    { private declarations }
    siCels,siFahr:single;
    iTmp:integer;
    boEditingCels:boolean;

  public
    { public declarations }
  end; 

var
  LDN004f1: TLDN004f1;

implementation

{$R *.lfm}

{ TLDN004f1 }

procedure TLDN004f1.buQuitClick(Sender: TObject);
begin
  close;
end;

procedure TLDN004f1.eCelsKeyPress(Sender: TObject; var Key: char);
begin
  boEditingCels:=true;
end;

procedure TLDN004f1.eFahrKeyPress(Sender: TObject; var Key: char);
begin
  boEditingCels:=false;
end;

procedure TLDN004f1.eFahrChange(Sender: TObject);
//May look strange, but remember that it can be
//  called various ways.
begin
  val(eFahr.text,siFahr,iTmp);
  if (iTmp<>0) and (boEditingCels=false) then begin
       eCels.text:='(Cannot convert)';
       end//no ; here
    else begin
       if boEditingCels=false then begin //**3
          siCels:=(5/9)*(siFahr-32);
          eCels.text:=floattostrf(siCels,ffFixed,6,2);
          end;//**3
       end;//of else's begin
end;

procedure TLDN004f1.eCelsChange(Sender: TObject);
//See eFahrChange
begin
  val(eCels.text,siCels,iTmp);
  if (iTmp<>0) and (boEditingCels=true) then begin
       eFahr.text:='(Cannot convert)';
       end//no ; here
    else begin
           if boEditingCels=true then begin //**3
              siFahr:=(9/5)*siCels+32;
              eFahr.text:=floattostrf(siFahr,ffFixed,6,2);
              end;//**3
       end;//of else's begin
end;


procedure TLDN004f1.FormCreate(Sender: TObject);
begin
  caption:='LDN004, version '+ver;
  boEditingCels:=false;
  siFahr:=98.7;
  eFahr.text:=floattostrf(siFahr,ffFixed,6,2);
end;

end.

